apiVersion: integration.rock8s.com/v1beta1
kind: Socket
metadata:
  name: {{ template "keycloak.name" . }}
  labels:
    app.kubernetes.io/name: {{ template "keycloak.name" . }}
    helm.sh/chart: {{ .Chart.Name }}-{{ .Chart.Version }}
    app.kubernetes.io/instance: {{ .Release.Name }}
    app.kubernetes.io/managed-by: {{ .Release.Service }}
spec:
  epoch: {{ now | unixEpoch | quote }}
  interface:
    config:
      plug:
        clientId:
          required: true
        attributes: {}
        preserve: {}
        clientSecret: {}
        consentRequired: {}
        description: {}
        directAccessGrantsEnabled: {}
        implicitFlowEnabled: {}
        name: {}
        protocol: {}
        realm: {}
        redirectUris: {}
        webOrigins: {}
      socket:
        keycloakAdminPassword:
          required: true
        keycloakBaseUrl:
          required: true
        defaultRealm:
          required: true
        keycloakAdminUsername: {}
  apparatus:
    endpoint: /socket
    containers:
      - image: registry.gitlab.com/bitspur/rock8s/keycloak-integration-apparatus:0.1.0
        imagePullPolicy: Always
        name: apparatus
        ports:
          - containerPort: 3000
            name: container
            protocol: TCP
      - name: kubectl
        image: bitnami/kubectl:1.17.12
        imagePullPolicy: IfNotPresent
        command:
          - /bin/sh
          - -c
          - kubectl proxy
  config:
    keycloakBaseUrl: {{ include "keycloak.keycloak-base-url" . }}
    defaultRealm: main
  configTemplate:
    keycloakAdminPassword: '{% .vars.BASE64_ENCODED_KEYCLOAK_ADMIN_PASSWORD | b64dec %}'
    keycloakAdminUsername: '{% .vars.BASE64_ENCODED_KEYCLOAK_ADMIN_USERNAME | b64dec %}'
  vars:
    - name: BASE64_ENCODED_KEYCLOAK_ADMIN_PASSWORD
      objref:
        version: v1
        kind: Secret
        name: {{ template "keycloak.name" . }}-initial-admin
        namespace: {{ .Release.Namespace }}
      fieldref:
        fieldPath: data.password
    - name: BASE64_ENCODED_KEYCLOAK_ADMIN_USERNAME
      objref:
        version: v1
        kind: Secret
        name: {{ template "keycloak.name" . }}-initial-admin
        namespace: {{ .Release.Namespace }}
      fieldref:
        fieldPath: data.username
